From 1549106cb02a216c2182e3c75cfc8aad13834d13 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 01 2020 00:26:23 +0000
Subject: [PATCH 1118/2232] Add move assignment operator for Error


---

diff --git a/include/cxx.h b/include/cxx.h
index d43854c..c545e50 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -259,6 +259,7 @@ public:
   ~Error() noexcept;
 
   Error &operator=(const Error &);
+  Error &operator=(Error &&) noexcept;
 
   const char *what() const noexcept override;
 
diff --git a/src/cxx.cc b/src/cxx.cc
index 7843b29..722a034 100644
--- a/src/cxx.cc
+++ b/src/cxx.cc
@@ -195,6 +195,17 @@ Error &Error::operator=(const Error &other) {
   return *this;
 }
 
+Error &Error::operator=(Error &&other) noexcept {
+  if (this != &other) {
+    std::exception::operator=(std::move(other));
+    this->msg = other.msg;
+    this->len = other.len;
+    other.msg = nullptr;
+    other.len = 0;
+  }
+  return *this;
+}
+
 const char *Error::what() const noexcept { return this->msg; }
 
 } // namespace cxxbridge05

